use std::process;

use kuska_ssb::api::dto::content::{SubsetQuery, TypedMessage};

use golgi::error::GolgiError;
use golgi::sbot::Sbot;

async fn run() -> Result<(), GolgiError> {
    let mut sbot_client = Sbot::init(None, None).await?;

    let id = sbot_client.whoami().await?;
    println!("{}", id);

    /*
    let name = TypedMessage::About {
        about: id,
        name: Some("golgi".to_string()),
        title: None,
        branch: None,
        image: None,
        description: None,
        location: None,
        start_datetime: None,
    };

    let name_msg_ref = sbot_client.publish(name).await?;
    println!("{}", name_msg_ref);

    let post = TypedMessage::Post {
        text: "golgi go womp womp".to_string(),
        mentions: None,
    };

    let post_msg_ref = sbot_client.publish(post).await?;
    println!("{}", post_msg_ref);

    let post_msg_ref = sbot_client
        .publish_description("this is a description")
        .await?;
    println!("description: {}", post_msg_ref);
    */

    let query = SubsetQuery::Type {
        op: "type".to_string(),
        string: "vote".to_string(),
    };
    let query_response = sbot_client.getsubset(query).await?;
    println!("{}", query_response);

    Ok(())
}

#[async_std::main]
async fn main() {
    if let Err(e) = run().await {
        eprintln!("Application error: {}", e);
        process::exit(1);
    }
}
